Subject: Re: Multicast packet loss

From: Neil Horman <[email-masked]>
Date: Sat, 31 Jan 2009 11:03:33 -0500

On Fri, Jan 30, 2009 at 11:41:23PM +0100, Eric Dumazet wrote:
> Kenny Chang a écrit :
> > Ah, sorry, here's the test program attached.
> > 
> > We've tried 2.6.28.1, but no, we haven't tried the 2.6.28.2 or the
> > 2.6.29.-rcX.
> > 
> > Right now, we are trying to step through the kernel versions until we
> > see where the performance drops significantly.  We'll try 2.6.29-rc soon
> > and post the result.
> 
> 2.6.29-rc contains UDP receive improvements (lockless)
> 
> Problem is multicast handling was not yet updated, but could be :)
> 
> 
> I was asking you "cat /proc/interrupts" because I believe you might
> have a problem NIC interrupts being handled by one CPU only (when having problems)
> 
That would be expected (if irqbalance is running), and desireable, since
spreading high volume interrupts like NICS accross multiple cores (or more
specifically multiple L2 caches), is going increase your cache line miss rate
significantly and decrease rx throughput.

Although you do have a point here, if the system isn't running irqbalance, and
the NICS irq affinity is spread accross multiple L2 caches, that would be a
point of improvement performance-wise.  

Kenny, if you could provide the /proc/interrupts info along with /proc/cpuinfo
and your stats that I asked about earlier, that would be a big help.

Regards
Neil